package com.cnbm.packing.dto;

import com.cnbm.packing.entity.WoPackagingBoxSubstrate;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

import java.math.BigDecimal;
import java.util.List;


/**
 * 包装箱表
 *
 * @author codeGenerator
 * @since  2023-02-20
 */
@Data
@ApiModel(value = "包装箱表DTO对象")
public class WoPackagingBoxDTO implements Serializable {
	private static final long serialVersionUID = 1L;



	@ApiModelProperty(value = "ID")
	private Long id;

	@ApiModelProperty(value = "订单ID")
	private Long orderId;

	@ApiModelProperty(value = "工单ID（舍弃啊）")
	private Long workOrderId;

	@ApiModelProperty(value = "包装箱编号，这个就是boxId,关联 t_wo_packaging_box表的 boxId")
	private String boxNo;

	@ApiModelProperty(value = "功率，单位瓦（舍弃）")
	private Integer power;

	@ApiModelProperty(value = "等级（舍弃）")
	private Integer grade;

	@ApiModelProperty(value = "基板数量，每个包装箱最大20片（舍弃）")
	private Integer substrateQuantity;

	@ApiModelProperty(value = "装箱完成时间，指的是包装完成时间")
	private LocalDateTime packagingTime;

	@ApiModelProperty(value = "打印时间（最近一次打印时间）")
	private LocalDateTime printTime;

	@ApiModelProperty(value = "打印状态：0、未打印，1、已打印")
	private Integer printStatus;

	@ApiModelProperty(value = "报工状态：0、未报工，1、已报工(舍弃)")
	private Integer completionReportingStatus;

	@ApiModelProperty(value = "备注")
	private String remark;

	@ApiModelProperty(value = "删除标志，是否有效:1 可用 0不可用")
	private Integer valid;

	@ApiModelProperty(value = "创建人")
	private Long creatorId;

	@ApiModelProperty(value = "创建人姓名")
	private String creatorName;

	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	@ApiModelProperty(value = "更新人")
	private Long updaterId;

	@ApiModelProperty(value = "更新人姓名")
	private String updaterName;

	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

	@ApiModelProperty(value = "版本号")
	private Integer version;

	@ApiModelProperty(value = "离开产线时间（舍弃）")
	private LocalDateTime leaveLineTime;

	@ApiModelProperty(value = "下片端口id（舍弃）")
	private String portId;

	@ApiModelProperty(value = "打印次数")
	private Integer printCount;

	@ApiModelProperty(value = "功率等级")
	private String powerLevel;

	@ApiModelProperty(value = "客户id（舍弃）")
	private Long customerId;

	@ApiModelProperty(value = "SAP MATERIAL,从t_wo_power_level 对应过来的")
	private String sapMaterial;

	@ApiModelProperty(value = "线体,从t_wo_power_level 对应过来的，1=F ; 2=S")
	private Integer lineBody;

	@ApiModelProperty(value = "模式，1-手动模式；2-自动模式")
	private Integer model;

	@ApiModelProperty(value = "是否到达包装台，1=到达；2=未达到")
	private Integer isArrived;

	@ApiModelProperty(value = "订单号")
	private String orderNum;

	@ApiModelProperty(value = "基板列表")
	private List<WoPackagingBoxSubstrate> substrateList;

	@ApiModelProperty(value = "颜色（物料号匹配）")
	private String color;

}