package com.cnbm.packing.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

import java.math.BigDecimal;


/**
 * 包装箱基板关联表 ( 基板表 )
 *
 * @author codeGenerator
 * @since  2023-02-21
 */
@Data
@ApiModel(value = "包装箱基板关联表 ( 基板表 )DTO对象")
public class WoPackagingBoxSubstrateDTO implements Serializable {
	private static final long serialVersionUID = 1L;



	@ApiModelProperty(value = "ID")
	private Long id;

	@ApiModelProperty(value = "包装箱ID，BoxId")
	private String packagingBoxId;

	@ApiModelProperty(value = "基板ID")
	private String woSubstrateId;

	@ApiModelProperty(value = "创建人")
	private Long creatorId;

	@ApiModelProperty(value = "创建人姓名")
	private String creatorName;

	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	@ApiModelProperty(value = "更新人")
	private Long updaterId;

	@ApiModelProperty(value = "更新人姓名")
	private String updaterName;

	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

	@ApiModelProperty(value = "版本号")
	private Integer version;

	@ApiModelProperty(value = "箱中位置")
	private Integer slot;

	@ApiModelProperty(value = "进入时间")
	private LocalDateTime inputTime;

	@ApiModelProperty(value = "删除标志，是否有效:1 可用 0不可用")
	private Integer valid;

	@ApiModelProperty(value = "SAP MATERIAL,从t_wo_power_level 对应过来的")
	private String sapMaterial;

	@ApiModelProperty(value = "线体,从t_wo_power_level 对应过来的，1=F ; 2=S")
	private Integer lineBody;

	@ApiModelProperty(value = "功率等级")
	private String powerLevel;

	@ApiModelProperty(value = "")
	private LocalDateTime lastUpdateTime;

	@ApiModelProperty(value = "补偿后的功率，pmpp")
	private Float pmpp;

	@ApiModelProperty(value = "订单名")
	private String orderName;

	@ApiModelProperty(value = "")
	private Long binclassFl1;

	@ApiModelProperty(value = "")
	private Long binclassFl2;

	@ApiModelProperty(value = "")
	private Float etaFl1;

	@ApiModelProperty(value = "")
	private Float etaFl2;

	@ApiModelProperty(value = "")
	private Float ffFl1;

	@ApiModelProperty(value = "")
	private Float ffFl2;

	@ApiModelProperty(value = "")
	private Float imppFl1;

	@ApiModelProperty(value = "")
	private Float imppFl2;

	@ApiModelProperty(value = "")
	private Float insolflashcontrolFl1;

	@ApiModelProperty(value = "")
	private Float insolflashcontrolFl2;

	@ApiModelProperty(value = "")
	private Float insolmppFl1;

	@ApiModelProperty(value = "")
	private Float insolmppFl2;

	@ApiModelProperty(value = "")
	private Float insolvocFl1;

	@ApiModelProperty(value = "")
	private Float insolvocFl2;

	@ApiModelProperty(value = "")
	private Float insolFl1;

	@ApiModelProperty(value = "")
	private Float insolFl2;

	@ApiModelProperty(value = "")
	private Float iscFl1;

	@ApiModelProperty(value = "")
	private Float iscFl2;

	@ApiModelProperty(value = "")
	private LocalDateTime measTimeFl1;

	@ApiModelProperty(value = "")
	private LocalDateTime measTimeFl2;

	@ApiModelProperty(value = "")
	private Float pmppFl1;

	@ApiModelProperty(value = "")
	private Float pmppFl2;

	@ApiModelProperty(value = "")
	private Float tcellFl1;

	@ApiModelProperty(value = "")
	private Float tcellFl2;

	@ApiModelProperty(value = "")
	private Float tmonicellFl1;

	@ApiModelProperty(value = "")
	private Float tmonicellFl2;

	@ApiModelProperty(value = "")
	private Float umppFl1;

	@ApiModelProperty(value = "")
	private Float umppFl2;

	@ApiModelProperty(value = "")
	private Float uocFl1;

	@ApiModelProperty(value = "")
	private Float uocFl2;

	@ApiModelProperty(value = "真实PMPP")
	private Float actualPmpp;

	@ApiModelProperty(value = "包装箱创建时间")
	private LocalDateTime boxCreateTime;

	@ApiModelProperty(value = "打印时间（最近一次打印时间）")
	private LocalDateTime printTime;

	@ApiModelProperty(value = "包装箱创建时间(转)")
	private String boxCreateTime1;

	@ApiModelProperty(value = "最近打印时间(转)")
	private String printTime1;

	@ApiModelProperty(value = "颜色（物料号匹配）")
	private String color;

}