package com.cnbm.packing.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.packing.dto.IdVo;
import com.cnbm.packing.dto.PowerReportDTO;
import com.cnbm.packing.dto.WoPackagingBoxDTO;
import com.cnbm.packing.entity.WoPackagingBox;
import com.cnbm.packing.entity.WoPackagingBoxSubstrate;
import com.cnbm.packing.param.PowerReportQueryParam;
import com.cnbm.packing.param.SubIdQueryParam;
import com.cnbm.packing.vo.R;
import com.cnbm.packing.vo.SubIdPageVo;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * 包装箱表
 *
 * @author codeGenerator
 * @since  2023-02-15
 */
public interface WoPackagingBoxServiceBiz extends CrudService<WoPackagingBox, WoPackagingBoxDTO> {

    PageData<WoPackagingBoxDTO> page (Map<String, Object> params);

    WoPackagingBoxDTO get(Long id);

    IdVo add(WoPackagingBoxDTO dto);

    void update(WoPackagingBoxDTO dto);

    void delete(Long[] ids);

    List<WoPackagingBoxDTO> list();

    WoPackagingBoxDTO printList(Long id);

    List<WoPackagingBoxSubstrate> substrateList (Map<String, Object> params);

    List<WoPackagingBox> boxList (String woSubstrateId);

    IdVo insertSubstrateManual(WoPackagingBoxDTO dto);

    void editSubstrateManual(WoPackagingBoxDTO dto);


    int updateIsArrivedByBoxNo(Integer isArrived, String boxNo);

    List<PowerReportDTO> powerReport(PowerReportQueryParam queryParam);
    List<String> orderNameList();

    R<IPage<SubIdPageVo>> subIdPage(SubIdQueryParam param);

    void setColor(List<WoPackagingBoxDTO> list);
}